// xPlaysound.cpp
//
#include "stdafx.h"
#include "VerInfo.h"

#define TIMER_PLAYSOUND		111

#define StringCchCopy(a, b, c) strncpy((a), (c), (b))
#define StringCchLength(a, b, c) *(c) = strlen((a)), S_OK
#define StringCchPrintf _snprintf

//PlaySound
#define   NOCOMPMAN     //  - dont include COMPMAN
#define   NODRAWDIB   //    - dont include DRAWDIB
#define   NOVIDEO     //    - dont include video capture interface
#define   NOAVIFMT    //    - dont include AVI file format structs
#define   NOMMREG     //    - dont include MMREG
#define   NOAVIFILE   //    - dont include AVIFile interface
//#define   NOMCIWND    //    - dont include AVIWnd class.
#define   NOAVICAP    //    - dont include AVICap class.
#define   NOMSACM     //    - dont include ACM stuff.
#include "vfw.h"

HINSTANCE hInstance;
HWND messageHandler;

void BangxPlaySound(HWND hwndCaller, LPCSTR pszArgs);

HWND m_hWndSoundFile = NULL;

int lsMessages[] = {
	LM_GETREVID,
	0
};

LRESULT WINAPI MessageHandlerProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case LM_GETREVID:
		{
			UINT uLength;
			StringCchPrintf((char*)lParam, 64, "%s.dll: %s", V_NAME, V_VERSION);
			
			if (SUCCEEDED(StringCchLength((char*)lParam, 64, &uLength)))
				return uLength;

			lParam = NULL;
			return 0;
		}
		
		case WM_TIMER:
		{
			switch( (int) wParam )
			{
				case TIMER_PLAYSOUND:
				{
					if (m_hWndSoundFile != NULL)
					{
						if (MCIWndGetEnd(m_hWndSoundFile) == MCIWndGetPosition(m_hWndSoundFile))
						{
							MCIWndStop(m_hWndSoundFile);

							KillTimer(messageHandler, TIMER_PLAYSOUND);
						}
					}
					else
					{
						KillTimer(messageHandler, TIMER_PLAYSOUND);
					}
					break;
				}

				default:
				{
					break;
				}
			}
		}
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}

BOOL __stdcall _DllMainCRTStartup(HINSTANCE hInst, DWORD fdwReason, LPVOID lpvRes)
{
	// We don't need thread notifications for what we're doing.  Thus, get
	// rid of them, thereby eliminating some of the overhead of this DLL
	DisableThreadLibraryCalls(hInst);

	return TRUE;
}

int initModuleEx(HWND hParent, HINSTANCE hInstance, const char *lsPath)
{
	WNDCLASSEX wc;

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_GLOBALCLASS;
	wc.lpfnWndProc = MessageHandlerProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hbrBackground = 0;
	wc.hCursor = 0;
	wc.hIcon = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = "xPlaysoundMessageHandler";
	wc.hIconSm = 0;

	RegisterClassEx(&wc);

	messageHandler = CreateWindowEx(WS_EX_TOOLWINDOW,
		"xPlaysoundMessageHandler",
		0,
		WS_POPUP,
		0, 0, 0, 0, 
		0,
		0,
		hInstance,
		0);

	if (!messageHandler)
		return 1;

	SendMessage(GetLitestepWnd(),
		LM_REGISTERMESSAGE,
		(WPARAM) messageHandler,
		(LPARAM) lsMessages);

	::hInstance = hInstance;

	AddBangCommand("!xPlaySound", BangxPlaySound);

	return 0;
}

void quitModule(HINSTANCE hInstance)
{
	if (m_hWndSoundFile != NULL)
	{
		MCIWndStop(m_hWndSoundFile);
		MCIWndDestroy(m_hWndSoundFile);
		m_hWndSoundFile = NULL;
	}
	
	RemoveBangCommand("!xPlaySound");

	SendMessage(GetLitestepWnd(),
		LM_UNREGISTERMESSAGE,
		(WPARAM) messageHandler,
		(LPARAM) lsMessages);

	DestroyWindow(messageHandler);

	UnregisterClass("xPlaysoundMessageHandler", hInstance);
}



//----------------------------------------------------------------
//----------------------------------------------------------------

	//=========================================================
	// Bang command handling
	//=========================================================

//!PlaySound "Path to wav|mp3|mid"
void BangxPlaySound(HWND hwndCaller, LPCSTR pszArgs)
{
	CString m_Path = pszArgs;
	m_Path.Remove('\"');
	m_Path.MakeLower();

	if (m_Path.Find(".wav") || m_Path.Find(".mp3") || m_Path.Find(".mid"))
	{
		HANDLE hFindHandle;
		WIN32_FIND_DATA FindData;

		hFindHandle = FindFirstFile(m_Path, &FindData);

		if (INVALID_HANDLE_VALUE != hFindHandle)
		{
			if ( !m_hWndSoundFile )
			{
				m_hWndSoundFile = MCIWndCreate(NULL, NULL, WS_MINIMIZE | MCIWNDF_NOMENU | MCIWNDF_NOERRORDLG, m_Path);
			}
			else
			{
				MCIWndStop(m_hWndSoundFile);

				MCIWndOpen(m_hWndSoundFile, (LPCTSTR) m_Path, NULL );
			}
			
			MCIWndPlay(m_hWndSoundFile);

			SetTimer(messageHandler, TIMER_PLAYSOUND, 1000, 0);
		}

		FindClose(hFindHandle);
	}
	else if (m_hWndSoundFile != NULL)
	{
		MCIWndStop(m_hWndSoundFile);
	}
}


//----------------------------------------------------------------
//----------------------------------------------------------------
